## kodi 20.0~alpha2+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
if(WIN32)
  # Version 3.20 is required for multi-config generator expressions to work
  cmake_minimum_required(VERSION 3.20)
endif()
project(kodi LANGUAGES CXX C ASM)

if(POLICY CMP0069)
  set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)
  cmake_policy(SET CMP0069 NEW)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules/buildtools)
if(DEPENDS_DIR)
  list(APPEND CMAKE_PREFIX_PATH ${DEPENDS_DIR})
endif()

# Set CORE_BUILD_DIR
set(CORE_BUILD_DIR build)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

message(STATUS "Source directory: ${CMAKE_SOURCE_DIR}")
message(STATUS "Build directory: ${CMAKE_BINARY_DIR}")
if(CMAKE_BINARY_DIR STREQUAL CMAKE_SOURCE_DIR)
  message(WARNING "In-source build detected. It is recommended to build out-of-source.")
endif()

# Hide messages from Check*.cmake (e.g. CheckCSourceCompiles)
if(NOT VERBOSE)
  set(CMAKE_REQUIRED_QUIET ON)
endif()

# Includes
include(cmake/modules/extra/ECMEnableSanitizers.cmake)
include(cmake/scripts/common/GeneratorSetup.cmake)
include(cmake/scripts/common/AddOptions.cmake)
include(cmake/scripts/common/Platform.cmake)
include(cmake/scripts/common/ArchSetup.cmake)
include(cmake/scripts/common/Macros.cmake)
include(cmake/scripts/common/ProjectMacros.cmake)
core_find_versions()
include(cmake/scripts/common/PathSetup.cmake)
include(cmake/scripts/common/CompilerSettings.cmake)
include(ExternalProject)
include(CMakeDependentOption)

# general
option(VERBOSE            "Enable verbose output?" OFF)
option(ENABLE_CLANGTIDY   "Enable clang-tidy support?" OFF)
option(ENABLE_CPPCHECK    "Enable cppcheck support?" OFF)
option(ENABLE_DVDCSS      "Enable libdvdcss support?" ON)
option(ENABLE_INCLUDEWHATYOUUSE "Enable include-what-you-use support?" OFF)
option(ENABLE_UPNP        "Enable UPnP support?" ON)
option(ENABLE_AIRTUNES    "Enable AirTunes support?" ON)
option(ENABLE_OPTICAL     "Enable optical support?" ON)
option(ENABLE_PYTHON      "Enable python support?" ON)
option(ENABLE_TESTING     "Enable testing support?" ON)

# Internal Depends - supported on all platforms
option(ENABLE_INTERNAL_CROSSGUID "Enable internal crossguid?" ON)
# use ffmpeg from depends or system
option(ENABLE_INTERNAL_FFMPEG "Enable internal ffmpeg?" OFF)
option(ENABLE_INTERNAL_RapidJSON "Enable internal rapidjson?" ON)
cmake_dependent_option(ENABLE_INTERNAL_FLATBUFFERS "Enable internal flatbuffers?" OFF "DEFINED USE_INTERNAL_LIBS;NOT USE_INTERNAL_LIBS" ON)
cmake_dependent_option(ENABLE_INTERNAL_NFS "Enable internal libnfs?" OFF "DEFINED USE_INTERNAL_LIBS;NOT USE_INTERNAL_LIBS" ON)
cmake_dependent_option(ENABLE_INTERNAL_PCRE "Enable internal pcre?" OFF "DEFINED USE_INTERNAL_LIBS;NOT USE_INTERNAL_LIBS" ON)
cmake_dependent_option(ENABLE_INTERNAL_TAGLIB "Enable internal taglib?" OFF "DEFINED USE_INTERNAL_LIBS;NOT USE_INTERNAL_LIBS" ON)

# Internal Depends - supported on UNIX platforms
if(UNIX)
  option(FFMPEG_PATH        "Path to external ffmpeg?" "")
  option(ENABLE_INTERNAL_FMT "Enable internal fmt?" OFF)
  option(ENABLE_INTERNAL_FSTRCMP "Enable internal fstrcmp?" OFF)
  option(ENABLE_INTERNAL_DAV1D "Enable internal dav1d?" OFF)
  option(ENABLE_INTERNAL_GTEST "Enable internal gtest?" OFF)
  option(ENABLE_INTERNAL_UDFREAD "Enable internal udfread?" OFF)
  option(ENABLE_INTERNAL_SPDLOG "Enable internal spdlog?" OFF)

  if(ENABLE_INTERNAL_SPDLOG)
    set(ENABLE_INTERNAL_FMT ON CACHE BOOL "" FORCE)
  endif()
endif()
# prefer kissfft from xbmc/contrib but let use system one on unices
cmake_dependent_option(ENABLE_INTERNAL_KISSFFT "Enable internal kissfft?" ON "UNIX" ON)
# System options
if(NOT WIN32)
  option(WITH_ARCH              "build with given arch" OFF)
  option(WITH_CPU               "build with given cpu" OFF)
endif()
if(CORE_SYSTEM_NAME STREQUAL linux)
  option(ENABLE_EVENTCLIENTS    "Enable event clients support?" OFF)
  option(ADDONS_CONFIGURE_AT_STARTUP "Configure binary addons at startup?" ON)
endif()

# set scope of INTERNAL_DEPS
set_property(GLOBAL PROPERTY INTERNAL_DEPS_PROP)

# Build static libraries per directory
if(NOT CMAKE_GENERATOR MATCHES "Visual Studio" AND NOT CMAKE_GENERATOR STREQUAL Xcode)
  set(ENABLE_STATIC_LIBS TRUE)
else()
  set(ENABLE_STATIC_LIBS FALSE)
endif()

core_find_git_rev(APP_SCMID FULL)

# Dynamically loaded libraries built with the project
add_custom_target(${APP_NAME_LC}-libraries)
set(LIBRARY_FILES "" CACHE STRING "" FORCE)
mark_as_advanced(LIBRARY_FILES)

set(INCLUDES ${CMAKE_SOURCE_DIR}
             ${CMAKE_SOURCE_DIR}/lib
             ${CMAKE_SOURCE_DIR}/xbmc
             ${CMAKE_SOURCE_DIR}/xbmc/${PLATFORM_DIR}
             ${CMAKE_SOURCE_DIR}/xbmc/cores/VideoPlayer
             ${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}
             ${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}/include)

if (NOT PLATFORMDEFS_DIR STREQUAL "")
  list(APPEND INCLUDES ${CMAKE_SOURCE_DIR}/xbmc/${PLATFORMDEFS_DIR})
endif()

find_package(PkgConfig)
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED QUIET)
list(APPEND DEPLIBS ${CMAKE_THREAD_LIBS_INIT})


foreach(depspec ${PLATFORM_REQUIRED_DEPS})
  # We need to specify ENABLE_${PLATFORM_REQUIRED_DEPS} in order for the
  # optional subdirectory for the specified platform to get built.
  split_dependency_specification(${depspec} dep version)
  string(TOUPPER ${dep} depup)
  if(NOT ${ENABLE_${depup}} STREQUAL AUTO AND NOT ${ENABLE_${depup}})
    message(WARNING "Your request to disable the dependency ${dep} required on platform ${CORE_PLATFORM_NAME} was ignored. Please choose another platform or add \"-DENABLE_${depup}=ON\" to your CMake command line to resolve this warning.")
  endif()
  set(ENABLE_${depup} "ON" CACHE BOOL "Force enabling required ${depup} support" FORCE)
endforeach()

# Required tools. Keep in alphabetical order please
set(required_buildtools FlatC
                        JsonSchemaBuilder
                        TexturePacker
)

# Optional build tools
set(optional_buildtools CCache
                        ClangFormat
                        ClangTidy
                        Cppcheck
                        IncludeWhatYouUse)

# Find build tools - Optional and required
core_optional_dep(${optional_buildtools})
core_require_dep(${required_buildtools})

# Required dependencies. Keep in alphabetical order please
set(required_deps ASS
                  Cdio
                  CrossGUID
                  Curl
                  FFMPEG
                  FlatBuffers
                  Fmt
                  FreeType
                  FriBidi
                  Fstrcmp
                  HarfBuzz
                  Iconv
                  KissFFT
                  LibDvd
                  Lzo2
                  OpenSSL>=1.1.0
                  PCRE
                  RapidJSON
                  Spdlog
                  Sqlite3
                  TagLib
                  TinyXML
                  ZLIB
                  ${PLATFORM_REQUIRED_DEPS})

# Optional dependencies. Keep in alphabetical order please
set(optional_deps Alsa
                  Avahi
                  Bluetooth
                  Bluray
                  CAP
                  CEC
                  Dav1d
                  DBus
                  Iso9660pp
                  LCMS2
                  LircClient
                  MDNS
                  MicroHttpd
                  NFS
                  Pipewire
                  Plist
                  PulseAudio
                  Python
                  SmbClient
                  Sndio
                  UDEV
                  Udfread
                  XSLT
                  ${PLATFORM_OPTIONAL_DEPS})

# Check optional deps first, since their availability can influence required ones, e.g. ffmpeg
core_optional_dep(${optional_deps})
core_require_dep(${required_deps})

if(ENABLE_MARIADBCLIENT AND NOT ENABLE_MARIADBCLIENT STREQUAL AUTO AND ENABLE_MYSQLCLIENT AND NOT ENABLE_MYSQLCLIENT STREQUAL AUTO)
  MESSAGE(FATAL_ERROR "You can not use MySql and MariaDB at the same time. Disable one by adding -DENABLE_MYSQLCLIENT=OFF or -DENABLE_MARIADBCLIENT=OFF.")
elseif(ENABLE_MYSQLCLIENT AND NOT ENABLE_MYSQLCLIENT STREQUAL AUTO)
  set(ENABLE_MARIADBCLIENT OFF CACHE BOOL "")
endif()

core_optional_dep(MariaDBClient)
if(NOT MARIADBCLIENT_FOUND)
  core_optional_dep(MySqlClient)
endif()

if(NOT UDEV_FOUND)
  core_optional_dep(LibUSB)
endif()

if(ENABLE_UPNP)
  list(APPEND DEP_DEFINES "-DHAS_UPNP=1")
endif()

if(ENABLE_OPTICAL)
  list(APPEND DEP_DEFINES -DHAS_DVD_DRIVE -DHAS_CDDA_RIPPER)
endif()

if(ENABLE_AIRTUNES)
  find_package(Shairplay)
  if(SHAIRPLAY_FOUND)
    core_require_dep(Shairplay)
  endif()
endif()

# find all folders containing addon.xml.in
# used to define ADDON_XML_OUTPUTS, ADDON_XML_DEPENDS and ADDON_INSTALL_DATA
# Function defined in ./cmake/scripts/common/Macros.cmake
set(outputFilterRegex "addons/xbmc.json")
find_addon_xml_in_files(${outputFilterRegex})

# Compile Info
add_custom_command(OUTPUT ${CORE_BUILD_DIR}/xbmc/CompileInfo.cpp
                          ${ADDON_XML_OUTPUTS}
                   COMMAND ${CMAKE_COMMAND} -DCORE_SOURCE_DIR=${CMAKE_SOURCE_DIR}
                                            -DCORE_SYSTEM_NAME=${CORE_SYSTEM_NAME}
                                            -DCORE_PLATFORM_NAME_LC="${CORE_PLATFORM_NAME_LC}"
                                            -DCORE_BUILD_DIR=${CORE_BUILD_DIR}
                                            -DCMAKE_BINARY_DIR=${CMAKE_BINARY_DIR}
                                            -DARCH_DEFINES="${ARCH_DEFINES}"
                                            -DAPP_SCMID=${APP_SCMID}
                                            -DAPP_COPYRIGHT_YEARS=${APP_COPYRIGHT_YEARS}
                                            -DAPP_BUILD_DATE=${APP_BUILD_DATE}
                                            -DAPP_SHARED_LIBRARY_SUFFIX="${APP_SHARED_LIBRARY_SUFFIX}"
                                            -DPYTHON_VERSION=${PYTHON_VERSION}
                                            -Dprefix=${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}
                                            -DKODI_WEBSERVER_EXTRA_WHITELIST="${KODI_WEBSERVER_EXTRA_WHITELIST}"
                                            -P ${CMAKE_SOURCE_DIR}/cmake/scripts/common/GenerateVersionedFiles.cmake
                   DEPENDS ${CMAKE_SOURCE_DIR}/version.txt
                           export-files
                           ${ADDON_XML_DEPENDS}
                           ${CMAKE_SOURCE_DIR}/xbmc/CompileInfo.cpp.in)
list(APPEND install_data ${ADDON_INSTALL_DATA})
add_library(compileinfo OBJECT ${CORE_BUILD_DIR}/xbmc/CompileInfo.cpp)
set_target_properties(compileinfo PROPERTIES FOLDER "Build Utilities")
target_compile_options(compileinfo PRIVATE "${SYSTEM_DEFINES} ${ARCH_DEFINES}")
add_dependencies(compileinfo fmt::fmt)

if(NOT MSVC)
  target_compile_options(compileinfo PUBLIC ${CORE_COMPILE_OPTIONS})
endif()

# RC File
if(WIN32)
  configure_file(${CMAKE_SOURCE_DIR}/xbmc/platform/win32/XBMC_PC.rc.in
                 ${CORE_BUILD_DIR}/xbmc/platform/win32/XBMC_PC.rc @ONLY)
  add_library(resources OBJECT ${CORE_BUILD_DIR}/xbmc/platform/win32/XBMC_PC.rc)
  set_target_properties(resources PROPERTIES FOLDER "Build Utilities")
  target_include_directories(resources PRIVATE ${CMAKE_SOURCE_DIR}/tools/windows/packaging/media)
  set(RESOURCES $<TARGET_OBJECTS:resources>)
endif()

# Generate messages
core_add_subdirs_from_filelist(${CMAKE_SOURCE_DIR}/cmake/messages/flatbuffers/*.txt)

include_directories(${INCLUDES} SYSTEM ${SYSTEM_INCLUDES})
add_compile_options(${ARCH_DEFINES} "${SYSTEM_DEFINES}" ${DEP_DEFINES} ${PATH_DEFINES})

set(core_DEPENDS "" CACHE STRING "" FORCE)
set(test_archives "" CACHE STRING "" FORCE)
set(test_sources "" CACHE STRING "" FORCE)
mark_as_advanced(core_DEPENDS)
mark_as_advanced(test_archives)
mark_as_advanced(test_sources)

# copy files to build tree
copy_files_from_filelist_to_buildtree(${CMAKE_SOURCE_DIR}/cmake/installdata/common/*.txt

=== xbmc/CMakeLists.txt ===
set(SOURCES Application.cpp
            AppInboundProtocol.cpp
            ApplicationPlayer.cpp
            ApplicationStackHelper.cpp
            AppEnvironment.cpp
            AppParamParser.cpp
            AppParams.cpp
            AutoSwitch.cpp
            BackgroundInfoLoader.cpp
            ContextMenuItem.cpp
            ContextMenuManager.cpp
            ContextMenus.cpp
            CueDocument.cpp
            DatabaseManager.cpp
            DbUrl.cpp
            DynamicDll.cpp
            FileItem.cpp
            FileItemListModification.cpp
            GUIInfoManager.cpp
            GUILargeTextureManager.cpp
            GUIPassword.cpp
            InfoScanner.cpp
            LangInfo.cpp
            MediaSource.cpp
            NfoFile.cpp
            PasswordManager.cpp
            PlayListPlayer.cpp
            PartyModeManager.cpp
            SectionLoader.cpp
            SeekHandler.cpp
            ServiceBroker.cpp
            ServiceManager.cpp
            SystemGlobals.cpp
            TextureCache.cpp
            TextureCacheJob.cpp
            TextureDatabase.cpp
            ThumbLoader.cpp
            URL.cpp
            Util.cpp
            XBDateTime.cpp)

set(HEADERS AppEnvironment.h
            AppParamParser.h
            AppParams.h
            Application.h
            AppInboundProtocol.h
            ApplicationPlayer.h
            ApplicationStackHelper.h
            AutoSwitch.h
            BackgroundInfoLoader.h
            CompileInfo.h
            ContextMenuItem.h
            ContextMenuManager.h
            ContextMenus.h
            CueDocument.h
            DatabaseManager.h
            DbUrl.h
            DllPaths.h
            DllPaths_win32.h
            DynamicDll.h
            FileItem.h
            FileItemListModification.h
            GUIInfoManager.h
            GUILargeTextureManager.h
            GUIPassword.h
            GUIUserMessages.h
            HDRStatus.h
            IFileItemListModifier.h
            IProgressCallback.h
            InfoScanner.h
            LangInfo.h
            LockType.h
            MediaSource.h
            NfoFile.h
            PartyModeManager.h
            PasswordManager.h
            PlayListPlayer.h
            SectionLoader.h
            SeekHandler.h
            ServiceBroker.h
            ServiceManager.h
            SortFileItem.h
            TextureCache.h
            TextureCacheJob.h
            TextureDatabase.h
            ThumbLoader.h
            URL.h
            Util.h
            XBDateTime.h
            system_egl.h
            system_gl.h)

if(ENABLE_OPTICAL)
  list(APPEND SOURCES Autorun.cpp)
  list(APPEND HEADERS Autorun.h)
endif()

core_add_library(xbmc)
if(CAP_FOUND)
  target_compile_definitions(${CORE_LIBRARY} PRIVATE -DHAVE_LIBCAP=1)
endif()

if(CORE_SYSTEM_NAME STREQUAL windowsstore)
  set_target_properties(${CORE_LIBRARY} PROPERTIES STATIC_LIBRARY_FLAGS "/ignore:4264")
endif()

=== xbmc/addons/CMakeLists.txt ===
set(SOURCES Addon.cpp
            AddonBuilder.cpp
            BinaryAddonCache.cpp
            AddonDatabase.cpp
            AddonInstaller.cpp
            AddonManager.cpp
            AddonRepos.cpp
            AddonStatusHandler.cpp
            AddonSystemSettings.cpp
            AddonUpdateRules.cpp
            AddonVersion.cpp
            AudioDecoder.cpp
            ContextMenuAddon.cpp
            ContextMenus.cpp
            ExtsMimeSupportList.cpp
            FontResource.cpp
            FilesystemInstaller.cpp
            GameResource.cpp
            ImageDecoder.cpp
            ImageResource.cpp
            LanguageResource.cpp
            PluginSource.cpp
            Repository.cpp
            RepositoryUpdater.cpp
            Scraper.cpp
            ScreenSaver.cpp
            Service.cpp
            Skin.cpp
            UISoundsResource.cpp
            VFSEntry.cpp
            Visualization.cpp
            Webinterface.cpp)

set(HEADERS Addon.h
            AddonBuilder.h
            AddonEvents.h
            AddonRepoInfo.h
            BinaryAddonCache.h
            AddonDatabase.h
            AddonInstaller.h
            AddonManager.h
            AddonProvider.h
            AddonRepos.h
            AddonStatusHandler.h
            AddonSystemSettings.h
            AddonUpdateRules.h
            AddonVersion.h
            AudioDecoder.h
            ContextMenuAddon.h
            ContextMenus.h
            ExtsMimeSupportList.h
            FilesystemInstaller.h
            FontResource.h
            GameResource.h
            IAddon.h
            IAddonSupportCheck.h
            ImageDecoder.h
            ImageResource.h
            LanguageResource.h
            PluginSource.h
            Repository.h
            RepositoryUpdater.h
            Resource.h
            Scraper.h
            ScreenSaver.h
            Service.h
            Skin.h
            UISoundsResource.h
            VFSEntry.h
            Visualization.h
            Webinterface.h)

core_add_library(addons)

=== xbmc/application/CMakeLists.txt ===
set(SOURCES ApplicationActionListeners.cpp
            ApplicationPlayerCallback.cpp
            ApplicationPowerHandling.cpp
            ApplicationSettingsHandling.cpp
            ApplicationSkinHandling.cpp
            ApplicationVolumeHandling.cpp)

set(HEADERS ApplicationActionListeners.h
            ApplicationPlayerCallback.h
            ApplicationPowerHandling.h
            ApplicationSettingsHandling.h
            ApplicationSkinHandling.h
            ApplicationVolumeHandling.h)

core_add_library(application)

=== xbmc/dialogs/CMakeLists.txt ===
set(SOURCES GUIDialogBoxBase.cpp
            GUIDialogBusy.cpp
            GUIDialogBusyNoCancel.cpp
            GUIDialogButtonMenu.cpp
            GUIDialogCache.cpp
            GUIDialogColorPicker.cpp
            GUIDialogContextMenu.cpp
            GUIDialogExtendedProgressBar.cpp
            GUIDialogFileBrowser.cpp
            GUIDialogGamepad.cpp
            GUIDialogKaiToast.cpp
            GUIDialogKeyboardGeneric.cpp
            GUIDialogKeyboardTouch.cpp
            GUIDialogMediaFilter.cpp
            GUIDialogMediaSource.cpp
            GUIDialogNumeric.cpp
            GUIDialogOK.cpp
            GUIDialogPlayEject.cpp
            GUIDialogPlayerControls.cpp
            GUIDialogPlayerProcessInfo.cpp
            GUIDialogProgress.cpp
            GUIDialogSeekBar.cpp
            GUIDialogSelect.cpp
            GUIDialogSimpleMenu.cpp
            GUIDialogSlider.cpp
            GUIDialogSmartPlaylistEditor.cpp
            GUIDialogSmartPlaylistRule.cpp
            GUIDialogSubMenu.cpp
            GUIDialogTextViewer.cpp
            GUIDialogVolumeBar.cpp
            GUIDialogYesNo.cpp)

set(HEADERS GUIDialogBoxBase.h
            GUIDialogBusy.h
            GUIDialogBusyNoCancel.h
            GUIDialogButtonMenu.h
            GUIDialogCache.h
            GUIDialogColorPicker.h
            GUIDialogContextMenu.h
            GUIDialogExtendedProgressBar.h
            GUIDialogFileBrowser.h
            GUIDialogGamepad.h
            GUIDialogKaiToast.h
            GUIDialogKeyboardGeneric.h
            GUIDialogKeyboardTouch.h
            GUIDialogMediaFilter.h
            GUIDialogMediaSource.h
            GUIDialogNumeric.h
            GUIDialogOK.h
            GUIDialogPlayEject.h
            GUIDialogPlayerControls.h
            GUIDialogPlayerProcessInfo.h
            GUIDialogProgress.h
            GUIDialogSeekBar.h
            GUIDialogSelect.h
            GUIDialogSimpleMenu.h
            GUIDialogSlider.h
            GUIDialogSmartPlaylistEditor.h
            GUIDialogSmartPlaylistRule.h
            GUIDialogSubMenu.h
            GUIDialogTextViewer.h
            GUIDialogVolumeBar.h
            GUIDialogYesNo.h
            IGUIVolumeBarCallback.h)

core_add_library(dialogs)

=== xbmc/favourites/CMakeLists.txt ===
set(SOURCES ContextMenus.cpp
            GUIDialogFavourites.cpp
            FavouritesService.cpp)

set(HEADERS ContextMenus.h
            GUIDialogFavourites.h
            FavouritesService.h)

core_add_library(favourites)

=== xbmc/pvr/CMakeLists.txt ===
set(SOURCES PVRCachedImage.cpp
	    PVRCachedImages.cpp
            PVRChannelNumberInputHandler.cpp
            PVRContextMenus.cpp
            PVRDatabase.cpp
            PVREdl.cpp
            PVREventLogJob.cpp
            PVRItem.cpp
            PVRManager.cpp
            PVRPlaybackState.cpp
            PVRStreamProperties.cpp
            PVRThumbLoader.cpp)

set(HEADERS PVRCachedImage.h
            PVRCachedImages.h
            PVRChannelNumberInputHandler.h
            PVRContextMenus.h
            PVRDatabase.h
            PVREdl.h
            PVREventLogJob.h
            PVRItem.h
            PVRManager.h
            PVRPlaybackState.h
            PVRStreamProperties.h
            PVRThumbLoader.h)

core_add_library(pvr)

=== xbmc/threads/CMakeLists.txt ===
set(SOURCES Event.cpp
            Thread.cpp
            Timer.cpp)

set(HEADERS Condition.h
            CriticalSection.h
            Event.h
            Lockables.h
            SharedSection.h
            SingleLock.h
            SystemClock.h
            Thread.h
            Timer.h
            IThreadImpl.h)

core_add_library(threads)

=== xbmc/utils/CMakeLists.txt ===
set(SOURCES ActorProtocol.cpp
            AlarmClock.cpp
            AliasShortcutUtils.cpp
            Archive.cpp
            Base64.cpp
            BitstreamConverter.cpp
            BitstreamReader.cpp
            BitstreamStats.cpp
            BitstreamWriter.cpp
            BooleanLogic.cpp
            CharArrayParser.cpp
            CharsetConverter.cpp
            CharsetDetection.cpp
            ColorUtils.cpp
            ContentUtils.cpp
            CPUInfo.cpp
            Crc32.cpp
            CSSUtils.cpp
            DatabaseUtils.cpp
            Digest.cpp
            DiscsUtils.cpp
            EndianSwap.cpp
            EmbeddedArt.cpp
            FileExtensionProvider.cpp
            Fanart.cpp
            FileOperationJob.cpp
            FileUtils.cpp
            FontUtils.cpp
            GroupUtils.cpp
            HTMLUtil.cpp
            HttpHeader.cpp
            HttpParser.cpp
            HttpRangeUtils.cpp
            HttpResponse.cpp
            InfoLoader.cpp
            JobManager.cpp
            JSONVariantParser.cpp
            JSONVariantWriter.cpp
            LabelFormatter.cpp
            LangCodeExpander.cpp
            LegacyPathTranslation.cpp
            Locale.cpp
            log.cpp
            Mime.cpp
            MovingSpeed.cpp
            Observer.cpp
            POUtils.cpp
            RecentlyAddedJob.cpp
            RegExp.cpp
            rfft.cpp
            RingBuffer.cpp
            RssManager.cpp
            RssReader.cpp
            ProgressJob.cpp
            SaveFileStateJob.cpp
            ScraperParser.cpp
            ScraperUrl.cpp
            Screenshot.cpp
            SortUtils.cpp
            Speed.cpp
            StreamDetails.cpp
            StreamUtils.cpp
            StringUtils.cpp
            StringValidation.cpp
            SystemInfo.cpp
            Temperature.cpp
            TextSearch.cpp
            TimeUtils.cpp
            URIUtils.cpp
            UrlOptions.cpp
            Utf8Utils.cpp
            Variant.cpp
            VC1BitstreamParser.cpp
            Vector.cpp
            XBMCTinyXML.cpp
            XMLUtils.cpp)

set(HEADERS ActorProtocol.h
            AlarmClock.h
            AliasShortcutUtils.h
            Archive.h
            Base64.h
            BitstreamConverter.h
            BitstreamReader.h
            BitstreamStats.h
            BitstreamWriter.h
            BooleanLogic.h
            CharArrayParser.h
            CharsetConverter.h
            CharsetDetection.h
            CPUInfo.h
            ColorUtils.h
            ContentUtils.h
            Crc32.h
            CSSUtils.h
            DatabaseUtils.h
            Digest.h
            DiscsUtils.h
            EndianSwap.h
            EventStream.h
            EventStreamDetail.h
            FileExtensionProvider.h
            Fanart.h
            FileOperationJob.h
            FileUtils.h
            FontUtils.h
            Geometry.h
            GlobalsHandling.h
            GroupUtils.h
            HDRCapabilities.h
            HTMLUtil.h
            HttpHeader.h
            HttpParser.h
            HttpRangeUtils.h
            HttpResponse.h
            IArchivable.h
            IBufferObject.h
            ILocalizer.h
            InfoLoader.h
            IPlatformLog.h
            IRssObserver.h
            IScreenshotSurface.h
            ISerializable.h
            ISortable.h
            IXmlDeserializable.h
            Job.h
            JobManager.h
            JSONVariantParser.h
            JSONVariantWriter.h
            LabelFormatter.h
            LangCodeExpander.h
            LegacyPathTranslation.h
            Locale.h
            log.h
            logtypes.h
            MathUtils.h
            MemUtils.h
            Mime.h
            MovingSpeed.h
            Observer.h
            params_check_macros.h
            POUtils.h
            ProgressJob.h
            RecentlyAddedJob.h
            RegExp.h
            rfft.h
            RingBuffer.h
            RssManager.h
            RssReader.h
            SaveFileStateJob.h
            ScopeGuard.h
            ScraperParser.h
            ScraperUrl.h
            Screenshot.h
            SortUtils.h
            Speed.h
            Stopwatch.h
            StreamDetails.h
            StreamUtils.h
            StringUtils.h
            StringValidation.h
            SystemInfo.h
            Temperature.h
            TextSearch.h
            TimeUtils.h
            TransformMatrix.h
            URIUtils.h
            UrlOptions.h
            Utf8Utils.h
            Variant.h
            VC1BitstreamParser.h
            Vector.h
            XBMCTinyXML.h
            XMLUtils.h
            XTimeUtils.h)

if(XSLT_FOUND)
  list(APPEND SOURCES XSLTUtils.cpp)
  list(APPEND HEADERS XSLTUtils.h)
endif()
if(EGL_FOUND)
  list(APPEND SOURCES EGLUtils.cpp
                      EGLFence.cpp)
  list(APPEND HEADERS EGLUtils.h
                      EGLFence.h)
endif()

# The large map trips the clang optimizer
if(CMAKE_CXX_COMPILER_ID STREQUAL Clang)
  set_source_files_properties(Mime.cpp PROPERTIES COMPILE_FLAGS -O0)
endif()

if(OPENGL_FOUND OR OPENGLES_FOUND)
  list(APPEND SOURCES GLUtils.cpp)
  list(APPEND HEADERS GLUtils.h)
endif()

if("gbm" IN_LIST CORE_PLATFORM_NAME_LC OR "wayland" IN_LIST CORE_PLATFORM_NAME_LC)
  list(APPEND SOURCES BufferObject.cpp
                      BufferObjectFactory.cpp)
  list(APPEND HEADERS BufferObject.h
                      BufferObjectFactory.h)

  if("gbm" IN_LIST CORE_PLATFORM_NAME_LC)
    list(APPEND SOURCES DumbBufferObject.cpp)
    list(APPEND SOURCES DumbBufferObject.h)
  endif()

  if(HAVE_LINUX_MEMFD AND HAVE_LINUX_UDMABUF)
    list(APPEND SOURCES UDMABufferObject.cpp)
    list(APPEND HEADERS UDMABufferObject.h)
  endif()

  if(HAVE_LINUX_DMA_HEAP)
    list(APPEND SOURCES DMAHeapBufferObject.cpp)
    list(APPEND HEADERS DMAHeapBufferObject.h)
  endif()

  if(GBM_HAS_BO_MAP AND "gbm" IN_LIST CORE_PLATFORM_NAME_LC)
    list(APPEND SOURCES GBMBufferObject.cpp)
    list(APPEND HEADERS GBMBufferObject.h)
  endif()

  if(EGL_FOUND)
    list(APPEND SOURCES EGLImage.cpp)
    list(APPEND HEADERS EGLImage.h)
  endif()

  if(LIBDRM_FOUND)
    list(APPEND SOURCES DRMHelpers.cpp)
    list(APPEND HEADERS DRMHelpers.h)
  endif()
endif()

core_add_library(utils)

if(NOT CORE_SYSTEM_NAME STREQUAL windows AND NOT CORE_SYSTEM_NAME STREQUAL windowsstore)
  if(HAVE_SSE2)
    target_compile_options(${CORE_LIBRARY} PRIVATE -msse2)
  endif()
endif()

=== tools/depends/native/Makefile ===
include ../Makefile.include

ifneq ($(shell test -f $(NATIVEPREFIX)/share/config.site && echo 1),1)
  $(error Error: $(NATIVEPREFIX)/share/config.site  is missing. Please reconfigure depends to generate it)
endif

# Keep in alphabetical order
NATIVE= \
  autoconf \
  autoconf-archive \
  automake \
  cmake \
  gas-preprocessor \
  gettext \
  giflib \
  heimdal \
  JsonSchemaBuilder \
  libjpeg-turbo \
  liblzo2 \
  libpng \
  libtool \
  m4 \
  meson \
  nasm \
  ninja \
  openssl \
  pcre \
  perlmodule-parseyapp \
  pkg-config \
  python3 \
  setuptools \
  swig \
  TexturePacker \
  zlib

ifneq ($(NATIVE_OS),osx)
  NATIVE += libffi
  LIBFFI = libffi
endif

ifeq ($(OS),darwin_embedded)
  NATIVE += dpkg xz tar ldid
endif

ifeq ($(OS),linux)
  NATIVE += expat wayland-scanner pugixml waylandpp-scanner
  EXPAT = expat

  ifeq ($(RENDER_SYSTEM),gles)
    NATIVE += MarkupSafe Mako
  endif
endif

.PHONY: $(NATIVE) native

all: native
	@echo "Dependencies built successfully."

# Dependency layout for parallel builds
autoconf-archive: autoconf
autoconf: m4
automake: autoconf
dpkg: automake gettext libtool pkg-config tar
heimdal: libtool
JsonSchemaBuilder: automake
libjpeg-turbo: cmake nasm
libpng: zlib automake
libtool: automake
Mako: MarkupSafe
meson: python3 setuptools
ninja: meson
openssl: zlib
pugixml: cmake
python3: $(EXPAT) $(LIBFFI) pkg-config zlib openssl autoconf-archive
setuptools: python3
swig: pcre
tar: xz automake
TexturePacker: automake pkg-config libpng liblzo2 giflib libjpeg-turbo
wayland-scanner: expat pkg-config
waylandpp-scanner: cmake pugixml

# python installs are not thread safe when using easy_install method.
# MarkupSafe doesn't really depend on ninja but we need to make the
# build sequential
MarkupSafe: ninja

#liblzo2 has stale packaged automake files that cause borked host/build detection
liblzo2: automake

native: $(NATIVE)
$(NATIVE):
	$(MAKE) -C $@
clean:
	for d in $(NATIVE); do $(MAKE) -C $$d clean; done

# Debug target, this will DELETE all data in staging!
test-dependencies:
	( for d in $(NATIVE); do \
	rm -rf $(NATIVEPREFIX); \
        mkdir -p $(NATIVEPREFIX)/include $(NATIVEPREFIX)/share $(NATIVEPREFIX)/bin; \
	cp -f config.site $(NATIVEPREFIX)/share/; \
	$(MAKE) distclean; \
	$(MAKE) $$d; done ) && echo "$@ built successfully"

distclean::
	for d in $(NATIVE); do $(MAKE) -C $$d distclean; done

=== xbmc/utils/test/CMakeLists.txt ===
set(SOURCES TestAlarmClock.cpp
            TestAliasShortcutUtils.cpp
            TestArchive.cpp
            TestBase64.cpp
            TestBitstreamStats.cpp
            TestCharsetConverter.cpp
            TestCPUInfo.cpp
            TestCrc32.cpp
            TestDatabaseUtils.cpp
            TestDigest.cpp
            TestEndianSwap.cpp
            TestFileOperationJob.cpp
            TestFileUtils.cpp
            TestGlobalsHandling.cpp
            TestHTMLUtil.cpp
            TestHttpHeader.cpp
            TestHttpParser.cpp
            TestHttpRangeUtils.cpp
            TestHttpResponse.cpp
            TestJobManager.cpp
            TestJSONVariantParser.cpp
            TestJSONVariantWriter.cpp
            TestLabelFormatter.cpp
            TestLangCodeExpander.cpp
            TestLocale.cpp
            Testlog.cpp
            TestMathUtils.cpp
            TestMime.cpp
            TestPOUtils.cpp
            TestRegExp.cpp
            Testrfft.cpp
            TestRingBuffer.cpp
            TestScraperParser.cpp
            TestScraperUrl.cpp
            TestSortUtils.cpp
            TestStopwatch.cpp
            TestStreamDetails.cpp
            TestStreamUtils.cpp
            TestStringUtils.cpp
            TestSystemInfo.cpp
            TestURIUtils.cpp
            TestUrlOptions.cpp
            TestVariant.cpp
            TestXBMCTinyXML.cpp
            TestXMLUtils.cpp)

set(HEADERS TestGlobalsHandlingPattern1.h)

core_add_test_library(utils_test)

=== tools/depends/native/libjpeg-turbo/Makefile ===
include ../../Makefile.include
PREFIX=$(NATIVEPREFIX)
PLATFORM=$(NATIVEPLATFORM)
DEPS = ../../Makefile.include Makefile 01-disable-executables.patch ../../download-files.include

# lib name, version
LIBNAME=libjpeg-turbo
VERSION=2.1.1
SOURCE=$(LIBNAME)-$(VERSION)
ARCHIVE=$(LIBNAME)-$(VERSION).tar.gz
SHA512=9cf61b4677b38e254063248a3fdbe138634d23a35ae8f2ee2661bdb3248b1d0500bd43201b8d9fe66c779d578074fd9ed19bc097ba22e10143530c2a19738673
include ../../download-files.include

CMAKE_OPTIONS := -DCMAKE_TOOLCHAIN_FILE= \
                 -DCMAKE_ASM_NASM_COMPILER:FILEPATH=$(NATIVEPREFIX)/bin/nasm \
                 -DENABLE_SHARED:BOOL=OFF \
                 -DWITH_JPEG8:BOOL=ON \
                 -DCMAKE_C_COMPILER="$(CC_BINARY_FOR_BUILD)" \
                 -DCMAKE_C_FLAGS="$(NATIVE_CFLAGS)" \
                 -DCMAKE_EXE_LINKER_FLAGS="$(NATIVE_LDFLAGS)" \
                 -DCMAKE_INSTALL_LIBDIR:STRING=lib

LIBDYLIB=$(PLATFORM)/build/libjpeg.a

all: .installed-$(PLATFORM)


$(PLATFORM): $(TARBALLS_LOCATION)/$(ARCHIVE).$(HASH_TYPE) $(DEPS)
	rm -rf $(PLATFORM)/*; mkdir -p $(PLATFORM)
	cd $(PLATFORM); $(ARCHIVE_TOOL) $(ARCHIVE_TOOL_FLAGS) $(TARBALLS_LOCATION)/$(ARCHIVE)
	cd $(PLATFORM); patch -p1 -i ../01-disable-executables.patch
	cd $(PLATFORM); $(CMAKE) -B build $(CMAKE_OPTIONS)

$(LIBDYLIB): $(PLATFORM)
	$(MAKE) -C $(PLATFORM)/build

.installed-$(PLATFORM): $(LIBDYLIB)
	$(MAKE) -C $(PLATFORM)/build install
	touch $@

clean:
	$(MAKE) -C $(PLATFORM) clean
	rm -f .installed-$(PLATFORM)

distclean::
	rm -rf $(PLATFORM) .installed-$(PLATFORM)

=== debian/changelog ===
kodi (2:20.0~alpha2+dfsg1-1build1) kinetic; urgency=medium

  * No-change rebuild against libspdlog1.10-fmt9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 26 Aug 2022 20:51:08 +0000

kodi (2:20.0~alpha2+dfsg1-1) unstable; urgency=medium

  * New upstream version 20.0~alpha2+dfsg1
  * d/copyright fixes:
    + Keep COMPONENT-VERSION files in tools/depends/target
    + Remove useless versioncheck addon (Closes: #1015163)
    + Bump copyright years
  * Remove obsoleted patches and update the rest:
    + Add patch fixing color conversion test (merged)
    + Add patch for overriding local tarball checksum (merged)
    + Add patch for ffmpeg 5 support (not merged) (Closes: #1004612)
    + Add patch for proper fix of EDL rounding (merged)
    + Add patch for building against libfmt 9.0.0 (merged) (Closes: #1014542)
  * d/rules fixes:
    + Don't rely on versionfile parsing
  * + Supply SHA256 hashes for libdvd*
  * Upload to unstable.

 -- Vasyl Gello <vasek.gello@gmail.com>  Wed, 03 Aug 2022 14:24:22 +0000

kodi (2:20.0~alpha1+dfsg1-2) experimental; urgency=medium

  * Fix failing tests and restore timezone picker (Closes:‌ #1011241)

 -- Vasyl Gello <vasek.gello@gmail.com>  Thu, 19 May 2022 15:08:49 +0000

kodi (2:20.0~alpha1+dfsg1-1) experimental; urgency=medium

  * New upstream version 20.0~alpha1+dfsg1
  * Leave only language packs in repo-resources-embedded
  * Branch out experimental
  * Restrict watchfile to next Debian stable codename
  * Add pipewire to build-dependencies
  * Refresh Kodi patches
  * Add workaround patches
  * Refresh cdatetime-std-chrono patches
  * Refresh headers-check.c
  * Use system RapidJSON
  * Bump libdate-tz C++ standard to 17 and enable StringView back

 -- Vasyl Gello <vasek.gello@gmail.com>  Mon, 16 May 2022 06:45:07 +0000

=== debian/control ===
Source: kodi
Priority: optional
Section: video
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Vasyl Gello <vasek.gello@gmail.com>
Build-Depends: autoconf,
               automake,
               autopoint,
               cmake,
               curl,
               debhelper-compat (= 13),
               default-jre:native,
               default-libmysqlclient-dev,
               dh-python,
               doxygen,
               fontforge-nox,
               fonts-dejavu-core,
               fonts-droid-fallback,
               gawk,
               gettext,
               gperf,
               groovy:native,
               libasound2-dev | libasound-dev,
               libass-dev,
               libavahi-client-dev,
               libavahi-common-dev,
               libavcodec-dev (>= 7:4.2.2),
               libavfilter-dev (>= 7:4.2.2),
               libavformat-dev (>= 7:4.2.2),
               libavutil-dev (>= 7:4.2.2),
               libbluetooth-dev,
               libbluray-dev (>= 1:0.7.0),
               libcap-dev,
               libcdio-dev,
               libcec-dev (>= 4~),
               libcommons-lang-java:native,
               libcrossguid-dev,
               libcurl4-gnutls-dev | libcurl-dev,
               libcwiid-dev [linux-any],
               libdav1d-dev (>= 0.7.0),
               libdbus-1-dev,
               libdrm-dev,
#               libdvdnav-dev, use patched embedded version
#               libdvdread-dev, use patched embedded version
               libegl1-mesa-dev,
               libflatbuffers-dev,
               libfmt-dev (>= 6.1.2),
               libfontconfig-dev,
               libfreetype-dev | libfreetype6-dev,
               libfribidi-dev,
               libfstrcmp-dev,
               libgbm-dev,
               libgcrypt-dev,
               libgif-dev,
               libgif-dev:native,
               libgl1-mesa-dev | libgl-dev,
               libglew-dev,
               libglu1-mesa-dev | libglu-dev,
               libgnutls28-dev,
               libgpg-error-dev,
               libgtest-dev (>= 1.10.0~),
               libinput-dev,
               libiso9660-dev,
               libiso9660++-dev,
               libjpeg-dev,
               libjpeg-dev:native,
               libkissfft-dev (>= 131.1.0~),
               liblcms2-dev,
               liblirc-dev | liblircclient-dev,
               libltdl-dev,
               liblzo2-dev,
               liblzo2-dev:native,
               libmicrohttpd-dev,
               libnfs-dev,
               libomxil-bellagio-dev [armel],
               libpcre3-dev,
               libpipewire-0.3-dev,
               libplist-dev,
               libpng-dev,
               libpng-dev:native,
               libpostproc-dev (>= 7:4.2.2),
               libpulse-dev,
               libpython3-dev,
               librsvg2-bin,
               libshairplay-dev (>= 0.9.0~),
               libsmbclient-dev,
               libsndio-dev,
               libspdlog-dev (>= 1:1.5.0),
               libsqlite3-dev,
               libswresample-dev (>= 7:4.2.2),
               libswscale-dev (>= 7:4.2.2),
               libtag1-dev (>= 1.8),
               libtinyxml-dev,
               libtool,
               libudev-dev,
               libudfread-dev (>= 1.0.0),
               libva-dev,
               libvdpau-dev,
               libxkbcommon-dev,
               libxrandr-dev,
               libxslt1-dev,
               libxt-dev,
               nasm [i386],
               python3-dev:any,
               rapidjson-dev,
               swig,
               unzip,
               uuid-dev,
               valgrind [amd64 i386],
               wayland-protocols,
               waylandpp-dev,
               zip,
               zlib1g-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/multimedia-team/kodi-media-center/kodi
Vcs-Git: https://salsa.debian.org/multimedia-team/kodi-media-center/kodi.git
Homepage: https://kodi.tv/

Package: kodi
Architecture: any
Depends: kodi-bin (>= ${source:Version}),
         kodi-bin (<< ${source:Version}.1~),
         kodi-data (>= ${source:Version}),
         ${misc:Depends}
Recommends: kodi-repository-kodi | kodi-repository,
            kodi-visualization-spectrum
Breaks: xbmc (<< 2:13.2+dfsg1-5~), ${kodi:APIBREAKS}
Provides: ${kodi:APIPROVIDES}
Replaces: xbmc (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (executable binaries)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains the kodi binaries.

Package: kodi-data
Architecture: all
Multi-Arch: foreign
Depends: mesa-utils,
         x11-utils,
         libjs-jquery,
         libjs-iscroll,
         ${misc:Depends}
Recommends: fonts-noto-hinted,
            fonts-noto-mono,
            fonts-roboto-hinted,
            fonts-roboto-unhinted
Breaks: xbmc (<< 2:13.2+dfsg1-5~)
Replaces: xbmc (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (arch-independent data package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains all the architecture independent data needed to have a
 working Kodi.

Package: kodi-bin
Architecture: any
Depends: python3-pil,
         python3-pycryptodome,
         ${python3:Depends},
         ${dlopenlibs:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
Recommends: ${shlibs:Recommends},
            udisks2
Pre-Depends: ${misc:Pre-Depends}
Breaks: xbmc-bin (<< 2:13.2+dfsg1-5~)
Conflicts: libgl1-mesa-swx11
Replaces: xbmc-bin (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (architecture-dependent files)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains the binaries needed to have a working Kodi.

Package: kodi-eventclients-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Open Source Home Theatre (Event Client Common package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package is the common package for Kodi Event Client.

Package: kodi-eventclients-python
Architecture: any
Depends: kodi-eventclients-common (= ${source:Version}),
         python3-bluez,
         ${python3:Depends},
         ${misc:Depends}
Breaks: kodi-eventclients-common (<< 2:19.4+dfsg1-1~)
Replaces: kodi-eventclients-common (<< 2:19.4+dfsg1-1~)
Description: Open Source Home Theatre (Event Client Python package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package is the virtual Python package for Kodi Event Client.

Package: kodi-eventclients-dev-common
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Breaks: kodi-eventclients-dev (<< 2:19.4+dfsg1-1~)
Replaces: kodi-eventclients-dev (<< 2:19.4+dfsg1-1~)
Description: Open Source Home Theatre (Event Client common dev package)
 Kodi, formerly known as XBMC is an award winning free and

=== debian/rules ===
#!/usr/bin/make -f

# Avoid custom build rule silencing
export V=1

# Include /usr/share/dpkg/pkg-info.mk to get DEB_{SOURCE,VERSION}
include /usr/share/dpkg/pkg-info.mk

# Include /usr/share/dpkg/architecture.mk to get DEB_HOST_{MULTI,}ARCH
include /usr/share/dpkg/architecture.mk

# bindnow breaks wrappers used in with libdvdread
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-bindnow

DATE_COMPONENT = libdate-tz-embedded
DVDNAV_COMPONENT = libdvdnav-embedded
DVDNAV_URL = tools/depends/target/libdvdnav/libdvdnav-embedded.tar.xz
DVDREAD_COMPONENT = libdvdread-embedded
DVDREAD_URL = tools/depends/target/libdvdread/libdvdread-embedded.tar.xz

export DEB_CFLAGS_MAINT_STRIP  = -O2
export DEB_CFLAGS_MAINT_APPEND  = -O3
export DEB_CXXFLAGS_MAINT_STRIP  = -O2
export DEB_CXXFLAGS_MAINT_APPEND  = -O3

BUILD_WAYLAND := yes
BUILD_GBM := yes

NUMCPU =
# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NUMCPU := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

# Various environment variables to set
export DEB_LDFLAGS_MAINT_APPEND = -latomic -lpthread
# for embedded libdvd* and Kodi from Debian patch:
export DEB_CPPFLAGS_MAINT_APPEND = -D_XBMC -DDEB_VERSION=\"$(DEB_VERSION)\"

KODI_PLATFORMS := x11

ifeq ($(BUILD_WAYLAND),yes)
	KODI_PLATFORMS := $(KODI_PLATFORMS) wayland
endif
ifeq ($(BUILD_GBM),yes)
	KODI_PLATFORMS := $(KODI_PLATFORMS) gbm
endif

# basilgello: keep these overrides to ensure CMake honors
# the 32-bit architecture requested by 'dpkg-buildpackage'
# (like 'i486-linux') on 64-bit machines (like 'amd64').
ifneq (,$(filter amd64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=x86_64-linux
else ifneq (,$(filter armel armhf,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=arm
else ifneq (,$(filter i386,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=i486-linux
else ifneq (,$(filter mipsel,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=mips
else ifneq (,$(filter mips64el,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=mips64
else ifneq (,$(filter ppc64el,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=ppc64
else ifneq (,$(filter riscv64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=riscv64
else ifneq (,$(filter s390x,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=s390x
endif

# basilgello: If cross-compiling, tell Kodi to look for native prerequisites
# in $(CURDIR)/native-tools, where the override_dh_autoconfigure step builds
# them for the build architecture (the native architecture of builder machine)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
EXTRA_FLAGS := $(EXTRA_FLAGS) \
	-DWITH_JSONSCHEMABUILDER=$(CURDIR)/native-tools/bin/JsonSchemaBuilder \
	-DWITH_TEXTUREPACKER=$(CURDIR)/native-tools/bin/TexturePacker
endif

# libdate-tz configuration options
DATE_OPTS=\
-DVERBOSE=1 \
-DUSE_SYSTEM_TZ_DB=ON \
-DMANUAL_TZ_DB=OFF \
-DUSE_TZ_DB_IN_DOT=OFF \
-DBUILD_SHARED_LIBS=OFF \
-DBUILD_TZ_LIB=ON \
-DCMAKE_CXX_STANDARD=17

# Kodi configuration options
#
#‌ basilgello: we build embedded libdate-tz as external to Kodi
# because the Kodi upstream requires us either to specify CMake
# toolchain file or build libdate-tz before Kodi is configured
#
# Two CMake variables are injected into CMake cache to disable
# `find_library(DATE_LIBRARY` and `find_include_dir(DATE_INCLUDE_DIR`
# processing: DATE_LIBRARY_RELEASE and DATE_INCLUDE_DIR.
#‌
# See cmake/modules/FindDate.cmake and --trace-expand CMake log for
# the underlying logic
KODI_OPTS=\
-DVERBOSE=1 \
-DUSE_LTO=$(NUMCPU) \
-DCMAKE_BUILD_TYPE=RelWithDebInfo \
-DENABLE_AIRTUNES=ON \
-DENABLE_ALSA=ON \
-DENABLE_AVAHI=ON \
-DENABLE_BLURAY=ON \
-DENABLE_CEC=ON \
-DENABLE_DBUS=ON \
-DENABLE_DEBUGFISSION=OFF \
-DENABLE_DVDCSS=OFF \
-DENABLE_EVENTCLIENTS=ON \
-DENABLE_INTERNAL_CROSSGUID=OFF \
-DENABLE_INTERNAL_DATE=OFF \
-DENABLE_INTERNAL_FFMPEG=OFF \
-DENABLE_INTERNAL_KISSFFT=OFF \
-DENABLE_INTERNAL_RapidJSON=OFF \
-DENABLE_MICROHTTPD=ON \
-DENABLE_MYSQLCLIENT=ON \
-DENABLE_NFS=ON \
-DENABLE_OPTICAL=ON \
-DENABLE_PULSEAUDIO=ON \
-DENABLE_SMBCLIENT=ON \
-DENABLE_UDEV=ON \
-DENABLE_UPNP=ON \
-DENABLE_VAAPI=ON \
-DENABLE_VDPAU=ON \
-DENABLE_XSLT=ON \
-DLIBDVDREAD_URL=$(DVDREAD_URL) \
-DLIBDVDNAV_URL=$(DVDNAV_URL) \
-DENABLE_LIRCCLIENT=ON \
-DNEON=False \
-DCORE_PLATFORM_NAME="$(KODI_PLATFORMS)" \
-DAPP_RENDER_SYSTEM=gl \
-DDATE_LIBRARY_RELEASE:FILEPATH=$(CURDIR)/lib/date/libdate-tz.a \
-DDATE_INCLUDE_DIR:PATH=$(CURDIR)/$(DATE_COMPONENT)/include \
$(EXTRA_FLAGS)

%:
	dh $@ --buildsystem cmake --with python3

override_dh_clean:
	#‌ Clean the optional language packs originating in repo-resources-embedded
	#‌ We rely on the fact that there are no optional resource.language.* in
	# system/addon-manifest.xml
	cd repo-resources-embedded && for i in resource.language.*; do \
		if grep -q "<addon optional=\"true\">$$i</addon>" \
			$(CURDIR)/system/addon-manifest.xml; \
		then \
			echo "Cleaning language pack $$i"; \
			rm -rf $(CURDIR)/addons/$$i; \
			sed -i "/<addon optional=\"true\">$$i</d" \
				$(CURDIR)/system/addon-manifest.xml; \
			sed -i "/$$i\//d" \
				$(CURDIR)/cmake/installdata/common/addons.txt; \
		fi; \
	done
	# ‌Perform the rest of cleaning
	dh_clean \
		addons/skin.estuary/media/from-debian-logo.png \
		addons/webinterface.default/ \
		debian/dh-addon/*.1 \
		lib/date/ \
		lib/gtest/ \
		media/Fonts/arial.ttf \
		native-tools/ \
		tools/depends/native/JsonSchemaBuilder/native/ \
		tools/depends/native/JsonSchemaBuilder/.installed-native \
		tools/depends/native/TexturePacker/native/ \
		tools/depends/native/TexturePacker/.installed-native \
		$(DVDNAV_URL) \
		$(DVDREAD_URL)

# fall back to old location of DejaVuSans.ttf if needed
ifneq ("$(wildcard /usr/share/fonts/truetype/dejavu/DejaVuSans.ttf)","")
DEJAVUSANS=/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf
else
DEJAVUSANS=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf
endif

media/Fonts/arial.ttf: debian/mergefonts.ff
	# work around #948876 until fontforge is fixed by using cached result
	fontforge -script $< \
		/usr/share/fonts/truetype/droid/DroidSansFallbackFull.ttf \
		$(DEJAVUSANS) \
		$@ || cp debian/extra/arial.ttf $@

lib/date/libdate-tz.a:
	# Produce libdate-tz.a for host architecture
	dh_auto_configure \
		--sourcedir "$(CURDIR)/$(DATE_COMPONENT)" \
		--builddir "$(CURDIR)/lib/date" \
		-- $(DATE_OPTS)
	dh_auto_build \
		--sourcedir "$(CURDIR)/$(DATE_COMPONENT)" \
		--builddir "$(CURDIR)/lib/date"

lib/gtest/lib/.libs/libgtest.a:
	cp -r /usr/src/gtest/ $(CURDIR)/lib/ && mkdir -p $(CURDIR)/lib/gtest/lib/.libs

addons/skin.estuary/media/from-debian-logo.png: debian/from-debian-logo.svg
	rsvg-convert -w 250 -h 82 -o $@ $<

override_dh_auto_configure: addons/skin.estuary/media/from-debian-logo.png lib/gtest/lib/.libs/libgtest.a media/Fonts/arial.ttf lib/date/libdate-tz.a
	#‌ Copy default webinterface addon
	cp -r $(CURDIR)/debian/webinterface-default $(CURDIR)/addons/webinterface.default
	#‌ Copy the optional language packs originating in repo-resources-embedded
	cd repo-resources-embedded && for i in resource.language.*; do \
		echo "Adding language pack $$i"; \
		cp -r $$i $(CURDIR)/addons/$$i; \
		sed -i "/<\/addons>/i\ \ <addon optional=\"true\">$$i<\/addon>" \
			$(CURDIR)/system/addon-manifest.xml; \
		echo "addons/$$i/*"‌ \
			1>>$(CURDIR)/cmake/installdata/common/addons.txt; \
	done
	#‌ Prepare archives from embedded libdvd*
	tar -cf $(DVDNAV_URL) $(DVDNAV_COMPONENT)
	tar -cf $(DVDREAD_URL) $(DVDREAD_COMPONENT)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	# We are cross-compiling!
	# Produce the JsonSchemaBuilder and TexturePacker
	# prerequisites for the build architecture
	cd tools/depends/native/JsonSchemaBuilder && \
		make NATIVEPREFIX=$(CURDIR)/native-tools
	cd tools/depends/native/TexturePacker && \
		make NATIVEPREFIX=$(CURDIR)/native-tools
endif
	dh_auto_configure -- $(KODI_OPTS) \

=== debian/watch ===
version=4

# Alpha bare git branch
#
# Since v20, bare git snapshots must follow the tagged release cycle:
#
#      pretty=20.0~alphaX+git%cd.%h, \
#      pretty=20.0~betaX+git%cd.%h, \
#      pretty=20.0~rcX+git%cd.%h, \
#
# where X starts with zero. The 'pretty' attribute must be changed manually
# after the correspondent tagged release is published.
#
#opts="mode=git, \
#      pgpmode=none, \
#      pretty=20.0~alpha0+git%cd.%h, \
#      repack, \
#      repacksuffix=+dfsg1, \
#      compression=xz, \
#      uversionmangle=s/\([\.0-9a-zA-Z]\)-.*$/\1/;s/rc/~rc/;s/a/~alpha/;s/b/~beta/;s/RC/~rc/;s/A/~alpha/;s/B/~beta/, \
#      dversionmangle=auto" \
#https://github.com/xbmc/xbmc \
#HEAD debian

# Tagged releases
# TODO: Change Kodi codename in tarball URL before packaging next Kodi major release
#
opts="repack, \
      compression=xz, \
      repacksuffix=+dfsg1,\
      uversionmangle=s/\([\.0-9a-zA-Z]\)-.*$/\1/;s/rc/~rc/;s/a/~alpha/;s/b/~beta/;s/RC/~rc/;s/A/~alpha/;s/B/~beta/, \
      dversionmangle=auto" \
https://github.com/xbmc/xbmc/releases .*archive/refs/tags/?(\d\S*)-Nexus\.tar\.gz

# date

opts="component=libdate-tz-embedded, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/HowardHinnant/date/tags .*archive/refs/tags/v?(\d\S*)\.tar\.gz \
ignore

# libdvdread

opts="component=libdvdread-embedded, \
      repack, \
      compression=xz, \
      pgpsigurlmangle=s/$/.asc/" \
https://download.videolan.org/pub/videolan/libdvdread/([\d][\d\.]+[a-z]?)/libdvdread-([\d][\d\.]+[a-z]?)\.tar\.(?:gz|bz2|xz) \
ignore

# libdvdnav

opts="component=libdvdnav-embedded, \
      repack, \
      compression=xz, \
      pgpsigurlmangle=s/$/.asc/" \
https://download.videolan.org/pub/videolan/libdvdnav/([\d][\d\.]+[a-z]?)/libdvdnav-([\d][\d\.]+[a-z]?)\.tar\.(?:gz|bz2|xz) \
ignore

# repo-resources

opts="component=repo-resources-embedded, \
      mode=git, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/xbmc/repo-resources \
heads/nexus ignore
